package top.meethigher.mock.instance.proxy;


import net.sf.cglib.proxy.Enhancer;
import net.sf.cglib.proxy.MethodInterceptor;
import net.sf.cglib.proxy.MethodProxy;

import java.lang.reflect.Constructor;
import java.lang.reflect.InvocationHandler;
import java.lang.reflect.Method;
import java.lang.reflect.Proxy;

public class MockInstanceHandler {

    public <T> T instance(Class<?> clazz) {
        if (clazz == null) {
            throw new IllegalArgumentException("参数 'clazz' 不可为空");
        }
        T t = (T) Enhancer.create(clazz, (MethodInterceptor) (o, method, objects, methodProxy) -> {
            System.out.println(method.getName());
            return method.invoke(o, objects);
        });
        return t;
    }


}
